!vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvC
!                                                                      C
!  Module name: USR1                                                   C
!  Purpose: This routine is called from the time loop and is           C
!           user-definable.  The user may insert code in this routine  C
!           or call appropriate user defined subroutines.  This        C
!           can be used for setting or checking errors in quantities   C
!           that vary with time.  This routine is not called from an   C
!           IJK loop, hence all indices are undefined.                 C
!                                                                      C
!  Author:                                            Date: dd-mmm-yy  C
!  Reviewer:                                          Date: dd-mmm-yy  C
!                                                                      C
!  Revision Number:                                                    C
!  Purpose:                                                            C
!  Author:                                            Date: dd-mmm-yy  C
!  Reviewer:                                          Date: dd-mmm-yy  C
!                                                                      C
!  Literature/Document References:                                     C
!                                                                      C
!  Variables referenced:                                               C
!  Variables modified:                                                 C
!                                                                      C
!  Local variables:                                                    C
!                                                                      C
!^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^C
!
      SUBROUTINE USR1
!...Translated by Pacific-Sierra Research VAST-90 2.06G5  12:17:31  12/09/98
!...Switches: -xf
      USE usr
      USE functions
      USE mpi_utility
      USE constant,  ONLY: C
      USE run,       ONLY: TIME
!!      USE output,    ONLY: USR_DT
      USE fldvar,    ONLY: EP_g, V_g, V_s !Theta_m
      USE geometry,  ONLY: VOL
      USE compar,    ONLY: myPE, PE_IO
!!      USE bc,        ONLY: BC_V_G 
!!      USE set_bc0_flow_mod
!!      USE toleranc,  ONLY: TOL_RESID

      IMPLICIT NONE

!-----------------------------------------------
!
!  Include files defining common blocks here
!
!
!  Define local variables here
!
      INTEGER :: ijk, ijmk
      DOUBLE PRECISION :: Vol_tot, flux_tot_y
!
!  Include files defining statement functions here
!
!
!  Insert user-defined code here
!
!     data analysis & printing 
 8882 FORMAT (2(E16.8, 2x))

!     Normalize vertical velocity variables to Vk' = Vk - jy
!     ie ' variables are relative to the zero net flux plane

      flux_tot_y = 0.0d0
      Vol_tot = 0.0d0
      DO IJK = IJKSTART3, IJKEND3
        IF (.NOT.IS_ON_myPE_wobnd(I_OF(IJK),J_OF(IJK),K_OF(IJK))) CYCLE
        IF (.NOT.FLUID_AT(IJK)) CYCLE
          IJMK = JM_OF(IJK)
          flux_tot_y = flux_tot_y + 0.5d0 * VOL(IJK) * &
                     ( (1.0d0 - EP_G(IJK))*(V_s(IJK,1) + V_s(IJMK,1)) + &
                              + EP_G(IJK) *(V_g(IJK)   + V_g(IJMK)))
!         Vol_tot = Vol_tot + VOL(IJK) 
      ENDDO

      CALL GLOBAL_ALL_SUM(flux_tot_y)
!     this only works for regular rect domains
!     CALL GLOBAL_ALL_SUM(Voltot) 
      Vol_tot = DBLE(XLENGTH*YLENGTH*ZLENGTH)
      flux_tot_y = flux_tot_y / Vol_tot
      
      IF (flux_tot_y .GT. 1.0d-15) THEN
        DO IJK = IJKSTART3, IJKEND3
          IF(.NOT.IS_ON_myPE_wobnd(I_OF(IJK), J_OF(IJK), K_OF(IJK))) CYCLE
          IF (.NOT.FLUID_AT(IJK)) CYCLE 
          V_g(IJK)   = V_g(IJK)   - flux_tot_y
          V_s(IJK,1) = V_s(IJK,1) - flux_tot_y 
        ENDDO
      ENDIF 


!     check for usr IO time 
!!      IF (TIME .GT. time_usr_write) THEN
!!!       increment next time to write user data
!!        time_usr_write = time_usr_write + USR_DT(1)
!!      ENDIF



!     print
      IF(myPE .NE. PE_IO) RETURN
      OPEN(UNIT=888,FILE='uio_stats.dat',STATUS='OLD',ACCESS='APPEND')
      WRITE(888,8882) TIME, flux_tot_y
      CLOSE(888)

      RETURN
      END SUBROUTINE USR1

